import { Component } from "@angular/core";

@Component({
	selector: "hierarchical-grid",
	template: `
		<h1>igHierarchicalGrid default template for Angular</h1>
		<ig-hierarchical-grid
				[(widgetId)]='id'
				[options]="hgridOptions" [changeDetectionInterval]='10000'>
		</ig-hierarchical-grid>
	`
})
export class HierarchicalGridComponent {

    public hgridOptions: IgHierarchicalGrid;
    public id: string;
    public data: any;
    public newProduct: any;
    public ds: any;

    constructor() {

        this.id = "hgrid1";
        this.ds = new $.ig.DataSource({
            dataSource: "https://reqres.in/api/products/3",
            responseDataKey: "result"
        });

        this.hgridOptions = {
            initialDataBindDepth: 1,
            responseDataKey: "result",
            dataSource: this.ds, // $.ajax({ url: "foo/bar" });
            primaryKey: "transactionId",
            // requestError: function (evt, ui) {
            //     if (ui.message.indexOf("401") > -1) {
            //         $("#gettoken").click()//document.getElementById("accessdenied").click(); }
            //     }
            //     else {
            //         return false;
            //     }
            // },
            width: "100%",
            autoGenerateColumns: false,
            columns: [
                { key: "ID", headerText: "PO Number #", dataType: "string", hidden: true },
                { key: "PostalCode", headerText: "PO Number #", dataType: "string", width: "150px" },
                {
                    key: "BirthDate", headerText: "PO Date", dataType: "date",
                    format: "MMM dd, yyyy",
                    dateDisplayType: "local", width: "210px"
                }

            ],
            // childrenDataProperty: "Employee",
            autoGenerateLayouts: false,
            features: [
                {
                    name: "Paging",
                    type: "remote", // remote
                    pageSize: 10,
                    recordCountKey: "TotalRecordsCount",
                    pageSizeDropDownLocation: "inpager",
                    pageIndexChanged: (evt, ui) => { window.scroll(0, 0); }

                },
                {
                    name: "Filtering",
                    type: "remote",
                    mode: "simple",
                    allowFiltering: true,
                    caseSensitive: false,
                },
            ],
            columnLayouts: [
                {
                    key: "child",
                    autoGenerateColumns: false,
                    width: "100%",
                    columns: [
                        { key: "transactionId", hidden: true },
                        { key: "status", hidden: true },
                        { key: "poStatus", hidden: true },
                        { key: "childManufacturerId", headerText: "Part#", hidden: true },
                        { key: "pO_ProductId1", headerText: "Part#", width: "100px" },
                        { key: "contract", headerText: "Contract", width: "300px" },
                        { key: "poDescription", headerText: "Description", width: "200px" },
                        { key: "pO_QuantityOrdered", headerText: "Qty", width: "65px" },
                        { key: "pO_UnitPrice", headerText: "Cost", width: "100px", template: "$${pO_UnitPrice}", columnCssClass: "numericAlignment", formatter: (value) => { parseFloat(value).toFixed(2).replace(/\d(?=(\d{3})+\.)/g, "$&,"); } },
                        { key: "totalPrice", headerText: "Cost Extension", width: "185px", template: "$${totalPrice}", columnCssClass: "numericAlignment", formatter: (value) => { parseFloat(value).toFixed(2).replace(/\d(?=(\d{3})+\.)/g, "$&,"); } }

                    ]
                }
            ]
        };
	}
}
